buildgcc: Fix colors for dash
[coreboot.git] / util / crossgcc / buildgcc
index 9211cfdd72c4f8bca24a86eb1d76adc1cefa52fb..ee2a81b5abdc2d4edf53920e1290c7f6eae16083 100755 (executable)
@@ -1,9 +1,11 @@
-#!/bin/bash
+#!/bin/sh
 #
 # Copyright (C) 2008-2010 by coresystems GmbH
 # written by Patrick Georgi <patrick.georgi@coresystems.de> and
 #            Stefan Reinauer <stefan.reinauer@coresystems.de>
 #
+# Copyright (C) 2011 by Sage Electronic Engineering
+#
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; version 2 of the License.
@@ -18,8 +20,8 @@
 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 #
 
-CROSSGCC_DATE="December 16th, 2010"
-CROSSGCC_VERSION="1.03"
+CROSSGCC_DATE="October 10th, 2011"
+CROSSGCC_VERSION="1.05"
 
 # default settings
 TARGETDIR=`pwd`/xgcc
@@ -27,15 +29,18 @@ TARGETARCH=i386-elf
 DESTDIR=
 
 # version numbers
-GMP_VERSION=5.0.1
-MPFR_VERSION=3.0.0
-MPC_VERSION=0.8.2
+GMP_VERSION=5.0.2
+MPFR_VERSION=3.1.0
+MPC_VERSION=0.9
 LIBELF_VERSION=0.8.13
-GCC_VERSION=4.5.2
-BINUTILS_VERSION=2.20.1
-GDB_VERSION=7.2
-W32API_VERSION=3.15
+GCC_VERSION=4.6.1
+GCC_AUTOCONF_VERSION=2.64
+BINUTILS_VERSION=2.21.1
+GDB_VERSION=7.3.1
+W32API_VERSION=3.17-2
+W32API_VERSION_SHORT=3.17
 MINGWRT_VERSION=3.18
+IASL_VERSION=20110922
 
 # archive locations
 GMP_ARCHIVE="ftp://ftp.gmplib.org/pub/gmp-${GMP_VERSION}/gmp-${GMP_VERSION}.tar.bz2"
@@ -45,8 +50,9 @@ LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
 GCC_ARCHIVE="ftp://ftp.fu-berlin.de/unix/languages/gcc/releases/gcc-${GCC_VERSION}/gcc-core-${GCC_VERSION}.tar.bz2"
 BINUTILS_ARCHIVE="http://ftp.gnu.org/gnu/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
 GDB_ARCHIVE="http://ftp.gnu.org/gnu/gdb/gdb-${GDB_VERSION}.tar.bz2"
-W32API_ARCHIVE="http://downloads.sourceforge.net/project/mingw/MinGW/BaseSystem/RuntimeLibrary/Win32-API/w32api-${W32API_VERSION}/w32api-${W32API_VERSION}-mingw32-src.tar.gz"
+W32API_ARCHIVE="http://downloads.sourceforge.net/project/mingw/MinGW/BaseSystem/RuntimeLibrary/Win32-API/w32api-${W32API_VERSION_SHORT}/w32api-${W32API_VERSION}-mingw32-src.tar.lzma"
 MINGWRT_ARCHIVE="http://downloads.sourceforge.net/project/mingw/MinGW/BaseSystem/RuntimeLibrary/MinGW-RT/mingwrt-${MINGWRT_VERSION}/mingwrt-${MINGWRT_VERSION}-mingw32-src.tar.gz"
+IASL_ARCHIVE="http://www.acpica.org/download/acpica-unix-${IASL_VERSION}.tar.gz"
 
 GMP_DIR="gmp-${GMP_VERSION}"
 MPFR_DIR="mpfr-${MPFR_VERSION}"
@@ -57,19 +63,20 @@ BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
 GDB_DIR="gdb-${GDB_VERSION}"
 W32API_DIR="w32api-${W32API_VERSION}-mingw32"
 MINGWRT_DIR="mingwrt-${MINGWRT_VERSION}-mingw32"
+IASL_DIR="acpica-unix-${IASL_VERSION}"
 
 SAVETEMPS=0
 SKIPGDB=0
 
-red='\e[0;31m'
-RED='\e[1;31m'
-green='\e[0;32m'
-GREEN='\e[1;32m'
-blue='\e[0;34m'
-BLUE='\e[1;34m'
-cyan='\e[0;36m'
-CYAN='\e[1;36m'
-NC='\e[0m' # No Color
+red='\033[0;31m'
+RED='\033[1;31m'
+green='\033[0;32m'
+GREEN='\033[1;32m'
+blue='\033[0;34m'
+BLUE='\033[1;34m'
+cyan='\033[0;36m'
+CYAN='\033[1;36m'
+NC='\033[0m' # No Color
 
 searchgnu()
 {
@@ -88,14 +95,14 @@ searchgnu()
        exit 1
 }
 
-TAR=`searchgnu tar`
-PATCH=`searchgnu patch`
-MAKE=`searchgnu make`
+TAR=`searchgnu tar` || exit $?
+PATCH=`searchgnu patch` || exit $?
+MAKE=`searchgnu make` || exit $?
 
 cleanup()
 {
        printf "Cleaning up temporary files... "
-       rm -rf build-* combined gcc-* gmp-* mpfr-* mpc-* libelf-* binutils-* gdb-* w32api-* mingwrt-*
+       rm -rf build-* combined gcc-* gmp-* mpfr-* mpc-* libelf-* binutils-* gdb-* w32api-* mingwrt-* acpica-*
        printf "${green}ok${NC}\n"
 }
 
@@ -126,6 +133,7 @@ myversion()
 
        cat << EOF
 Copyright (C) 2008-2010 by coresystems GmbH
+Copyright (C) 2011 by Sage Electronic Engineering
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -139,15 +147,15 @@ GNU General Public License for more details.
 EOF
 }
 
-printf "${blue}Welcome to the ${red}coresystems${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
+printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
 
 # Look if we have getopt. If not, build it.
 export PATH=$PATH:.
 getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
 
 # parse parameters.. try to find out whether we're running GNU getopt
-getoptbrand="`getopt -V`"
-if [ "${getoptbrand:0:6}" == "getopt" ]; then
+getoptbrand="`getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,'`"
+if [ "${getoptbrand}" = "getopt" ]; then
        # Detected GNU getopt that supports long options.
        args=`getopt -l version,help,clean,directory:,platform:,jobs:,destdir:,savetemps,skip-gdb Vhcd:p:j:D:tG -- "$@"`
        eval set "$args"
@@ -182,6 +190,7 @@ done
 GDB_PACKAGE="GDB"
 if [ $SKIPGDB -eq 1 ]; then
        printf "Will skip GDB ... ${green}ok${NC}\n"
+       GDB_ARCHIVE=""
        GDB_PACKAGE=""
 fi
 
@@ -190,14 +199,12 @@ if [ "$TARGETARCH" = "i386-mingw32" ]; then
        MINGW_ARCHIVES="$W32API_ARCHIVE $MINGWRT_ARCHIVE"
 fi
 
-if [ ${GCC_VERSION} == "4.5.0" -o ${GCC_VERSION} == "4.6.0" ]; then
-  # coreboot does not like the GOLD linker
-  # USE_GOLD="--enable-gold"
-  USE_GOLD=""
-  GCC_OPTIONS="--enable-lto"
-fi
+# coreboot does not like the GOLD linker
+# USE_GOLD="--enable-gold"
+USE_GOLD=""
+GCC_OPTIONS="--enable-lto"
 
-if [ ${GCC_VERSION} == "4.6.0" ]; then
+if [ ${GCC_VERSION} = "4.6.2" ]; then
   if [ ! -r tarballs/gcc-core-${GCC_VERSION}.tar.bz2 ]; then
     printf "Pre-Release GCC ${GCC_VERSION}, checking out subversion trunk\n"
     mkdir -p tarballs/.tmp
@@ -216,7 +223,7 @@ fi
 
 printf "Downloading tar balls ... \n"
 mkdir -p tarballs
-for ARCHIVE in $GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE $MINGW_ARCHIVES; do
+for ARCHIVE in $GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE $MINGW_ARCHIVES $IASL_ARCHIVE; do
        FILE=`basename $ARCHIVE`
        printf " * $FILE "
        test -f tarballs/$FILE && printf "(cached)" || (
@@ -237,17 +244,20 @@ if [ "$TARGETARCH" = "i386-mingw32" ]; then
 fi
 
 printf "Unpacking and patching ... \n"
-for PACKAGE in GMP MPFR MPC LIBELF GCC BINUTILS $GDB_PACKAGE $MINGW_PACKAGES; do
+for PACKAGE in GMP MPFR MPC LIBELF GCC BINUTILS $GDB_PACKAGE $MINGW_PACKAGES IASL; do
        archive=$PACKAGE"_ARCHIVE"
-       archive=${!archive}
+       archive="`eval echo '$'$archive`"
        dir=$PACKAGE"_DIR"
-       test -d ${!dir} || (
+       dir="`eval echo '$'${dir}`"
+       test -d ${dir} || (
                printf " * `basename $archive`\n"
                FLAGS=zxf
-               test ${archive:${#archive}-2:2} = "gz" && FLAGS=zxf
-               test ${archive:${#archive}-3:3} = "bz2" && FLAGS=jxf
+               suffix=`echo $archive | sed 's,.*\.,,'`
+               test "$suffix" = "gz" && FLAGS=zxf
+               test "$suffix" = "bz2" && FLAGS=jxf
+               test "$suffix" = "lzma" && FLAGS="--lzma -xf"
                $TAR $FLAGS tarballs/`basename $archive`
-               for patch in patches/${!dir}_*.patch; do
+               for patch in patches/${dir}_*.patch; do
                        test -r $patch || continue
                        printf "   o `basename $patch`\n"
                        $PATCH -s -N -p0 < `echo $patch`
@@ -262,6 +272,7 @@ if [ "$TARGETARCH" = "i386-mingw32" ]; then
        mv $MINGWRT_DIR/include/* $W32API_DIR/include/* $TARGETDIR/i386-mingw32/sys-include
 fi
 
+CC=cc
 if [ `uname` = "Darwin" ]; then
        #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
 
@@ -275,13 +286,14 @@ if [ `uname` = "Darwin" ]; then
        else
                OPTIONS="ABI=32"
        fi
-       # old check:
-       #OPTIONS="ABI=32"
-       #touch .architecture_check.c
-       #gcc .architecture_check.c -c -o .architecture_check.o
-       #ARCH=`file .architecture_check.o |cut -f5 -d\ `
-       #test  "$ARCH" = "x86_64" && OPTIONS="ABI=64"
-       #rm .architecture_check.c .architecture_check.o
+
+       # In Xcode 4 the default compiler was switched to gcc-llvm.
+       # However, this compiler fails to compile gcc 4.6.x. As a
+       # workaround it's possible to compile gcc with gcc-4.2 or
+       # clang.
+       if $CC -v 2>&1 | grep -q LLVM; then
+               CC=clang
+       fi
 fi
 
 mkdir -p build-gmp build-mpfr build-mpc build-libelf build-binutils build-gcc
@@ -300,7 +312,7 @@ printf "Building GMP ${GMP_VERSION} ... "
        $MAKE $JOBS || touch .failed
        $MAKE install DESTDIR=$DESTDIR || touch .failed
        if [ ! -f .failed ]; then touch .success; fi
-) &> build-gmp/crossgcc-build.log
+) > build-gmp/crossgcc-build.log 2>&1
 test -r build-gmp/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
 test -r build-gmp/.failed && exit 1
 fi
@@ -310,8 +322,10 @@ fi
 #      ln -s $DESTDIR$TARGETDIR $TARGETDIR
 #fi
 
-# Now set CFLAGS to match GMP CFLAGS.
-HOSTCFLAGS=`grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2`
+# Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
+# as GCC 4.6.x fails if it's there.
+HOSTCFLAGS=`grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
+           sed s,-pedantic,,`
 
 if [ -f build-mpfr/.success ]; then
        printf "Skipping MPFR as it is already built\n"
@@ -333,7 +347,7 @@ printf "Building MPFR ${MPFR_VERSION} ... "
        fi
 
        if [ ! -f .failed ]; then touch .success; fi
-) &> build-mpfr/crossgcc-build.log
+) > build-mpfr/crossgcc-build.log 2>&1
 test -r build-mpfr/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
 test -r build-mpfr/.failed && exit 1
 fi
@@ -353,7 +367,7 @@ printf "Building MPC ${MPC_VERSION} ... "
        $MAKE install DESTDIR=$DESTDIR || touch .failed
 
        if [ ! -f .failed ]; then touch .success; fi
-) &> build-mpc/crossgcc-build.log
+) > build-mpc/crossgcc-build.log 2>&1
 test -r build-mpc/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
 test -r build-mpc/.failed && exit 1
 fi
@@ -372,7 +386,7 @@ printf "Building libelf ${LIBELF_VERSION} ... "
        $MAKE install DESTDIR=$DESTDIR || touch .failed
 
        if [ ! -f .failed ]; then touch .success; fi
-) &> build-libelf/crossgcc-build.log
+) > build-libelf/crossgcc-build.log 2>&1
 test -r build-libelf/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
 test -r build-libelf/.failed && exit 1
 fi
@@ -382,6 +396,12 @@ if [ -f build-binutils/.success ]; then
 else
 printf "Building binutils ${BINUTILS_VERSION} ... "
 (
+       # What a pain: binutils don't come with configure
+       # script anymore. Create it:
+       cd binutils-${BINUTILS_VERSION}/
+       autoconf
+       cd ..
+       # Now build binutils
        cd build-binutils
        rm -f .failed
        ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR --target=${TARGETARCH} \
@@ -390,7 +410,7 @@ printf "Building binutils ${BINUTILS_VERSION} ... "
        $MAKE $JOBS || touch .failed
        $MAKE install DESTDIR=$DESTDIR || touch .failed
        if [ ! -f .failed ]; then touch .success; fi
-) &> build-binutils/crossgcc-build.log
+) > build-binutils/crossgcc-build.log 2>&1
 test -r build-binutils/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
 test -r build-binutils/.failed && exit 1
 fi
@@ -400,6 +420,19 @@ if [ -f build-gcc/.success ]; then
 else
 printf "Building GCC ${GCC_VERSION} ... "
 (
+       # Even worse than binutils: GCC does not come with configure
+       # script anymore, but also enforces an obsolete autoconf version
+       # to create it. This is a poster child of how autotools help make
+       # software portable.
+       cd gcc-${GCC_VERSION}
+       sed '/dnl Ensure exactly this Autoconf version is used/d' \
+               config/override.m4 > config/override.m4.new
+       autoconf_version=`autoconf -V | grep "autoconf" | tr ' ' '\n' | tail -1`
+       sed "s/${GCC_AUTOCONF_VERSION}/${autoconf_version}/g" \
+               config/override.m4.new > config/override.m4
+       autoconf
+       cd ..
+       # Now, finally, we can build gcc:
        cd build-gcc
        export PATH=$PATH:$DESTDIR$TARGETDIR/bin
        rm -f .failed
@@ -408,10 +441,12 @@ printf "Building GCC ${GCC_VERSION} ... "
        # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
        # but it does not seem to work properly. At least the host library
        # libiberty is not compiled with CFLAGS_FOR_BUILD.
-       CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
+       CC="$CC" CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" \
+               CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
                --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
                --target=${TARGETARCH} --disable-werror --disable-shared \
                --disable-libssp --disable-bootstrap --disable-nls \
+               --disable-libquadmath \
                $GCC_OPTIONS --enable-languages="c" $USE_GOLD \
                --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
                --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
@@ -420,7 +455,7 @@ printf "Building GCC ${GCC_VERSION} ... "
        $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" || touch .failed
        $MAKE install DESTDIR=$DESTDIR || touch .failed
        if [ ! -f .failed ]; then touch .success; fi
-) &> build-gcc/crossgcc-build.log
+) > build-gcc/crossgcc-build.log 2>&1
 test -r build-gcc/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
 test -r build-gcc/.failed && exit 1
 fi
@@ -440,11 +475,29 @@ printf "Building GDB ${GDB_VERSION} ... "
        $MAKE $JOBS || touch .failed
        $MAKE install DESTDIR=$DESTDIR || touch .failed
        if [ ! -f .failed ]; then touch .success; fi
-) &> build-gdb/crossgcc-build.log
+) > build-gdb/crossgcc-build.log 2>&1
 test -r build-gdb/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
 test -r build-gdb/.failed && exit 1
 fi
 
+if [ -f $IASL_DIR/compiler/.success ]; then
+       printf "Skipping IASL as it is already built\n"
+else
+printf "Building IASL ${IASL_VERSION} ... "
+(
+       cd $IASL_DIR/compiler
+       export PATH=$PATH:$DESTDIR$TARGETDIR/bin
+       rm -f .failed
+       CFLAGS="$HOSTCFLAGS"
+       $MAKE || touch .failed
+       rm -f $DESTDIR$TARGETDIR/bin/iasl || touch .failed
+       cp iasl $DESTDIR$TARGETDIR/bin || touch .failed
+       if [ ! -f .failed ]; then touch .success; fi
+) > $IASL_DIR/compiler/crossgcc-build.log 2>&1
+test -r $IASL_DIR/compiler/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
+test -r $IASL_DIR/compiler/.failed && exit 1
+fi
+
 if [ $SAVETEMPS -eq 0 ]; then
        printf "Cleaning up... "
        rm -rf ${GMP_DIR} build-gmp
@@ -454,6 +507,7 @@ if [ $SAVETEMPS -eq 0 ]; then
        rm -rf ${BINUTILS_DIR} build-binutils
        rm -rf ${GCC_DIR} build-gcc
        rm -rf ${GDB_DIR} build-gdb
+       rm -rf ${IASL_DIR}
        printf "${green}ok${NC}\n"
 else
        printf "Leaving temporary files around... ${green}ok${NC}\n"